-- Exit if oUF isn't loaded
if not oUF then return end

--local loadAddon = function()
	LoadAddOn("LibRangeCheck-2.0")
	local updateEveryXFrame = 10 -- @ 30 FPS, update 3 times pr sec
	local updateCount = -90 -- @ Hold updates for 1-3 sec
	local RangeCheck = LibStub("LibRangeCheck-2.0")
	if not RangeCheck then return false end
	local print = function(m) DEFAULT_CHAT_FRAME:AddMessage(tostring(m)) end
	local objects = { }
	local tinsert = tinsert
	local rangeAlpha = {
		[0] = 1,
		[31] = .7,
		[100] = .3,
		[1000] = .2,
	}
	do
		-- Populate the rest of the table
		local rA = rangeAlpha
		rangeAlpha[-1] = 1
		local max = 40
		for i=0, max do
			if not rA[i] then rA[i] = rA[i-1] end
		end
	end
	
	--for k,v in pairs(rangeAlpha) do print(k..":"..v) end

	local e = CreateFrame("Frame", nil, UIParent)
	local max
	e:SetScript("OnUpdate", function()
		updateCount = updateCount + 1
		if updateCount < updateEveryXFrame then return end
		updateCount = 1

		for _,object in pairs(objects) do
			if object.unit and object:IsShown() then
				_, max = RangeCheck:getRange(object.unit, true)
				--print("Max: "..(max or "nil").." for unit "..(object.unit or "nil"))
				object:SetAlpha(rangeAlpha[max or 1000] or 1)
			end
		end
	end)

	local hook = function(object)
		if not object.TargeRangeCheck then return end
		tinsert(objects, object)
	end

	-- Append to all existing frames
	for _,object in pairs(oUF.objects) do hook(object) end

	-- Append to frames created later on
	oUF:RegisterInitCallback(hook)
	
	return true
--[[end

local loader = CreateFrame("Frame", nil, UIParent)
loader:RegisterEvent("PLAYER_ENTERING_WORLD")
loader:SetScript("OnEvent", function()
	loadAddon()
	loader:UnregisterEvent("PLAYER_ENTERING_WORLD")
	loader:Hide()
	loader = nil
end)
--]]